

function evaluate ()
% Label.txt: the ground trugh
% Label_est.txt: the submission
Label_true = load('Label.txt');
Label_true_vec = reshape(Label_true, [size(Label_true,1)*size(Label_true,2),1]); 

Label_est = load('Label_est.txt');
Label_est_vec = reshape(Label_est, [size(Label_est,1)*size(Label_est,2),1]); 

% acucracy
acc = length(find(Label_true_vec==Label_est_vec)) / length(Label_true_vec); 
disp(['Accuracy: ' num2str(acc*100) '%']); 

% confusion matrix
C = confusionmat(Label_true_vec,Label_est_vec);
CMatrix = C;
CMatrix = 100*CMatrix./(repmat(sum(CMatrix,2),[1,size(CMatrix,2)]));
disp('Confusion matrix'); 
disp(CMatrix); 

% F1 score
[f1, recall, precision] = fscore(C);
disp(['F1 score: ' num2str(f1)]);


end


function [f1, recall, precision] = fscore(CMatrix)

[nC,nP] = size(CMatrix);

for i=1:nC
    recall(i) = CMatrix(i,i)/(eps+sum(CMatrix(i,:)));
end

for i=1:nP
    precision(i) = CMatrix(i,i)/(eps+sum(CMatrix(:,i)));
end

f1i = (2*recall.*precision) ./ (eps+recall + precision); 
f1 = mean(f1i);

end